function AMOPLSResults=AMOPLS_OrthoNum(X, OrthoNum, GrpsCritNum, interactions, plots);
% ANOVA Multiblock Orthogonal Projections to Latent Structures
% Performs multiblock OPLS on a series of tables generated by ANOVA deomposition
% (similar to ANOVA-PCA, ASCA and AComDim).
% 
% function AMOPLSResults=AMOPLS(X, GrpsCritNum, interactions, plots);
%
% JB 2015-2016
%
%Input arguments:
%---------------
% X:  (nXrows x nXcols) matrix of initial data to be decomposed into ANOVA matrices
% OrthoNum: Number of orthogonal components
% GrpsCritNum: (nXrows x nGrps) matrix of group numbers for each classification criterion
% Interactions: 0=Main effects only, 1=First-order
% Plots: 0=No figures, 1=some figures;
%
%Output arguments:
%-----------------
% AMOPLSResults: Structure with fields:
%
% AMOPLSResults.koplsModel.Y
% AMOPLSResults.ANOVASaliences
% AMOPLSResults.koplsModel.ANOVASaliences_raw
% AMOPLSResults.RSR
% AMOPLSResults.MaxTab
% AMOPLSResults.NumTab
% AMOPLSResults.loadings
% AMOPLSResults.scores
% AMOPLSResults.RelativeSumOfSquares
% AMOPLSResults.RelativeVariance
% AMOPLSResults.SumOfSquaresANOVA
% AMOPLSResults.FacNames
%
% AMOPLSResults.In : Input data and ANOVA tables
% AMOPLSResults.In.X : (nXrows x nXcols) original data matrix (X)
% AMOPLSResults.In.Grps : (nXrows x nGrps) groups numbers for factors and interactions
% AMOPLSResults.In.X_mean : (nTables x nXrows x nXcols) 3D array of removed group mean vectors 
% AMOPLSResults.In.X_i : (nTables x nXrows x nXcols) 3D array after removing X_mean
% AMOPLSResults.In.X_NoRes: (nTables x nXrows x nXcols) 3D array of group mean vectors
% AMOPLSResults.In.X_Res=X_Res;
% AMOPLSResults.In.Titre : (nTables x 1) list of strings with labels of Factors;
%
% Reference:
% J. Boccard, S. Rudaz
% Exploring Omics data from designed experiments using Analysis of Variance Multiblock Orthogonal Partial Least Squares
% Analytica Chimica Acta, 920, 18-28, 2016
%
%%
[nXrows,nXcols]=size(X);
[nXrows, nGrpCrits]=size(GrpsCritNum);
GrpsCritNumTemp=GrpsCritNum;

switch nargin
    case 3
        plots=1;
    case 2
        plots=1;
        interactions=1;   
end


%% ANOVA-like variance decomposition
% Global mean
mean_i(1,:)=nanmean(X)';
meantab_i(1,:,:)=ones(nXrows,1)*mean_i(1,:);

% Subtract the column mean from each value
X_i(1,:,:)=X-squeeze(meantab_i(1,:,:));

titre{1}='X-column means';

%% Main factor Effects
if plots>0
    disp('ANOVA variance decomposition of')
    disp('- Main effects')
end

for i=1:nGrpCrits
    mean_i=[];
    NumGrps(i)=max(GrpsCritNum(:,i));
    vec_i=y2Grps(GrpsCritNum(:,i));
    vecmat{i+1}=vec_i;
    Grps(:,i)=Grps2y(vec_i);

    X_temp=squeeze(X_i(i,:,:));
    for k=1:NumGrps(i); 
        mean_i(k,:)=nanmean(X_temp(Grps(:,i)==k,:),1);
    end;

    meantab_i(i+1,:,:)=vec_i*mean_i;
    X_i(i+1,:,:)=squeeze(X_i(i,:,:))-squeeze(meantab_i(i+1,:,:));
    titre{i+1}=[num2str(i)] ;
end;

%% 2 factor Interactions

if interactions>0
    if plots>0
        disp('- First order interaction')
    end
    
    ij=nGrpCrits+2;
    for i=1:nGrpCrits
        for j=i+1:nGrpCrits
            % Variable to combine the Factors - Debug >10 levels JB 2016
            mean_i=[];
            vec_temp=GrpsCritNum(:,i)*10^2+GrpsCritNum(:,j)*10^0;
            vec_i=y2Grps(vec_temp);
            vecmat{ij}=vec_i;
            Grps(:,ij-1)=Grps2y(vec_i);
            NumGrps(ij-1)=size(vec_i,2);
            X_temp=squeeze(X_i(ij-1,:,:));
            for k=1:NumGrps(ij-1); 
                mean_i(k,:)=nanmean(X_temp(Grps(:,ij-1)==k,:),1);
            end;

            meantab_i(ij,:,:)=vec_i*mean_i;
            X_i(ij,:,:)=squeeze(X_i(ij-1,:,:))-squeeze(meantab_i(ij,:,:));

            titre{ij}=[num2str(i),'x',num2str(j)] ;
            ij=ij+1;
        end
    end
end

%% Residuals
foo=size(titre,2);
titre{foo+1}=['Residuals'] ;

%% Number of tables
[NumTab,RowsTab,ColsTab]=size(X_i);

%% Means (Y) / Means + residuals(Xi)
for i=1:NumTab-1 
    X_NoRes(i,:,:)=squeeze(meantab_i(i+1,:,:));
    X_Res(i,:,:)=squeeze(meantab_i(i+1,:,:))+squeeze(X_i(NumTab,:,:));
end;

% Just residuals
X_Res(NumTab,:,:)=squeeze(X_i(NumTab,:,:));


%% multiblock OPLS

W_mat=zeros(nXrows,nXrows);

Y=[];
for i=1:NumTab
    if i<NumTab
        [U,S,V] = svd(squeeze(X_NoRes(i,:,:)),'econ');
        foo=diag(S);
        tol=max(size(squeeze(X_NoRes(i,:,:))))*eps(norm(squeeze(X_NoRes(i,:,:))));
        k = find(foo<tol,1); % Find non-zero LVs
        Y=[Y, U(:,1:k-1).*repmat(foo(1:k-1)',nXrows,1)];
        RelVar{i}=foo(1:k-1)/sum(foo(1:k-1));
    end
    temp=squeeze(X_Res(i,:,:))*squeeze(X_Res(i,:,:))';
%     temp=koplsKernel(squeeze(X_Res(i,:,:)),[],'p',1);
    xnorm(i)=norm(temp,'fro');
    AMat{i}=temp/xnorm(i);
	W_mat=W_mat+AMat{i};  
end

AMOPLSResults.koplsModel=koplsModel(W_mat,Y,size(Y,2),OrthoNum,'mc','mc');

% Compute explained variance, blocks contributions and loadings

for j=1:NumTab
	for k=1:size(Y,2)
        lambda(j,k)=AMOPLSResults.koplsModel.T(:,k)'*AMat{j}*AMOPLSResults.koplsModel.T(:,k);
    end
    for l=1:OrthoNum
        lambda(j,k+l)=AMOPLSResults.koplsModel.To(:,l)'*AMat{j}*AMOPLSResults.koplsModel.To(:,l);
    end
    if j>1
        AbsSS(j-1)=sum(sum(squeeze(meantab_i(j,:,:)).^2));
    end
end
AbsSS(NumTab)=sum(sum(squeeze(X_i(NumTab,:,:)).^2));
TotalSS=sum(AbsSS);
RelSS=AbsSS/TotalSS;

lambda_raw=lambda;

for i=1:size(lambda,2)
    lambda(:,i)=lambda(:,i)/sum(lambda(:,i));
    [val,MaxTab(i)]=max(lambda(:,i));
end

for i=1:size(Y,2)
    loadings(:,i)=squeeze(X_Res(MaxTab(i),:,:))'*AMOPLSResults.koplsModel.T(:,i)/(AMOPLSResults.koplsModel.T(:,i)'*AMOPLSResults.koplsModel.T(:,i));
end;

for i=1:OrthoNum
    loadings(:,size(Y,2)+i)=squeeze(X_Res(MaxTab(size(Y,2)+i),:,:))'*AMOPLSResults.koplsModel.To(:,i)/(AMOPLSResults.koplsModel.To(:,i)'*AMOPLSResults.koplsModel.To(:,i));
end;

for i=1:NumTab
	RSR(i)=lambda(NumTab,size(Y,2)+1)/lambda(i,size(Y,2)+1); % Factor/Noise ratio
end

scores=[AMOPLSResults.koplsModel.T AMOPLSResults.koplsModel.To];

%% Plot AMOPLS results
if plots>0
    figure;
    bar(RelSS);
    title('ANOVA Decomposition - Sum Of Squares');
    set(gca,'XTickLabel',titre(2:end));
    
    %Figs=double(int8(NumTab/2));
    Figs=double(int8((size(Y,2)+1)/2));
    figure;
    for i=1:size(Y,2)
        subplot(Figs,2,i);
        plot(scores(:,i),'b-x'), axis tight;
        %text([1:RowsTab],scores(:,i),num2str(Grps(:,MaxTab(i))));
        title(['AMOPLS Scores - tp' num2str(i) ': Effect ' titre{MaxTab(i)+1}]);
    end
    subplot(Figs,2,size(Y,2)+1);
    plot(scores(:,size(Y,2)+1),'b-x'), axis tight;
    title(['AMOPLS Scores - to: Residuals']);
    
    figure;
    for i=1:size(Y,2);
        subplot(Figs,2,i);
        bar(lambda(:,i),'r','BarWidth',0.2), axis tight;
        temp=xlim;
        temp(1,1)=0;
        xlim(temp)
        title(['AMOPLS Lambda - lp', num2str(i) ': Effect ' titre{MaxTab(i)+1}]);
    end;
    subplot(Figs,2,size(Y,2)+1);
    bar(lambda(:,size(Y,2)+1),'r','BarWidth',0.2), axis tight;
    temp=xlim;
    temp(1,1)=0;
    xlim(temp)
    title(['AMOPLS Lambda - lo: Residuals']);
    
    figure;
    for i=1:size(Y,2);
        subplot(Figs,2,i);
        plot(loadings(:,i),'b-'), axis tight;
        title(['AMOPLS Loadings - pp' num2str(i) ': Effect ' titre{MaxTab(i)+1}]);
    end;  
    subplot(Figs,2,size(Y,2)+1);
    plot(loadings(:,size(Y,2)+1),'b-'), axis tight;
    title(['AMOPLS Loadings - po: Residuals']);
end

%%

AMOPLSResults.koplsModel.Y=Y;
AMOPLSResults.ANOVASaliences=lambda;
AMOPLSResults.koplsModel.ANOVASaliences_raw=lambda_raw;
AMOPLSResults.RSR=RSR;
AMOPLSResults.MaxTab=MaxTab;
AMOPLSResults.NumTab=NumTab;
AMOPLSResults.loadings=loadings;
AMOPLSResults.scores=scores;
AMOPLSResults.RelativeSumOfSquares=RelSS;
AMOPLSResults.RelativeVariance=RelVar;
AMOPLSResults.SumOfSquaresANOVA=AbsSS;
AMOPLSResults.FacNames=titre;

AMOPLSResults.In.X=X;
AMOPLSResults.In.Y=Y;
AMOPLSResults.In.Grps=Grps;
AMOPLSResults.In.X_mean=meantab_i;
AMOPLSResults.In.X_i=X_i;
AMOPLSResults.In.X_NoRes=X_NoRes;
AMOPLSResults.In.X_Res=X_Res;
AMOPLSResults.In.Titre=titre;

